/*
*****************************************************************************
*      Program -> Unique, searches specified database and field name for
*                 duplicate values. ie: PERSONNEL->SSN for the Same SSN
*                 entered twice.
*   Written by -> James W Heikkila Jr
*  Last Update -> 22 Oct 92
*        Notes -> Compile with CLIPPER 5.01
******************************************************************************
*/
/*     Define Dependancies of #Include Files  */

        #Include "Directry.ch"                // Directory/File structure
        #Include "Box.ch"                     // Definitions.

/*     Define Necessary Variables             */

// Attribute and Color Converstion Commands for Shadowing //
#define ATTR_CONV(fore, back) (back) * 16 + (fore)
#define BLACK   0
#define WHITE   7
#define DK_GRAY 8   && 8 is really dark grey
#define COL_SHADOW_ATTRIBUTE ATTR_CONV(DK_GRAY,BLACK)
#define BW_SHADOW_ATTRIBUTE ATTR_CONV(WHITE,BLACK)
//



Local  aDbf:={}, mGetchoice, mDatabase:=space(12),;
       mField:=space(10), mTemporary:="Unique.dbf", mDisp:=.t.,;
       aDirectory:=Directory("*.DBF", "D"),;
       aFields:={}, I, mAny:=space(1), aRec:={}, aVal:={}, mCheck,;
       nPos:=0, aDuplicate:={}, oldcolor:=setcolor(), mRec:=0




/*     Set up System Enviroments              */

Set Exact         OFF
Set Scoreboard    OFF
Set Date to       JAPAN                    /* YY/MM/DD Format */
Set key 272 to    Done
Setcolor("gr+/b")
CLS

Do While .T. .or. lastkey() != 27

aDbf:={}
aFields:={}
aDuplicate:={}
mRec:=0
nPos:=0
mDatabase:=space(12)
mField:=space(10)
mDisp:=.t.



/*      Set up the Main Background Screen     */

@ 1,0 clear to 23, 79
@ 1,0,23,79 Box B_DOUBLE + Chr(177)
@ 0,0 say padc("Unique Field Finder",80) color "N+/bg"


/*      Set up Info Window                     */

@ 6, 15 Clear to 11, 65
@ 6, 15 to 11, 65 DOUBLE
Sha_shadow(6,15,11,65)
 @ 7, 22 say "ENTER DATABASE NAME      : "
 @ 8,22 say "ENTER FIELD NAME         : "
 @ 9,22 say "ENTER TEMPORARY FILE NAME: "
 @ 10,22 say "DISPLAY OUTPUT TO SCREEN : "



       /* Check if aDirectory is Empty or NIL
        * If not, Evaluate every dbf file and add it's name to the
        * aDbf Array for use with the picklist
        *
        */

       if Empty(aDirectory)
            @ 24, 21 say "[ No Databases in Default Directory ]" color "*GR+/B"
            @ 7, 22 say "Enter Database Name      : " Get mDatabase pict "@!"
            Read
       else
            Aeval(aDirectory, {|aFile| aadd(aDBF, aFile[F_NAME])})
            @ 24, 0
            @ 24, 27 say "[ Hit ESC to key new name ]" color "GR+/B"
            @ 15,4 Clear to 21, 17
            @ 15,4 to 21, 17 DOUBLE
            sha_shadow(15,4,21,17)
            @ 15, 7 Say "[ FILE ]"
            if(mGetchoice:=aChoice(16,5,20,16,aDBF)) != 0
                mDatabase:=aDBF[mGetchoice]
            else
                @ 7, 22 say "ENTER DATABASE NAME      :" Get mDatabase pict "@!"
                Read
                   if mDatabase == nil
                     cls
                     quit
                   end
            endif
        endif

@ 7, 22 say "ENTER DATABASE NAME      : "+mDatabase pict "@!"
/*      Open Selected Database   */
Select A
Use &mDatabase New

/*      Compile Fieldnames for Pick-List       */

        For I = 1 to Fcount()
           aadd(aFields, Fieldname(I))
        Next I


/*       Display Pick-List of Field names      */
        @ 15, 24 Clear to 21, 37
        @ 15, 24 to 21, 37 DOUBLE
        sha_shadow(15,24,21,37)
        @ 15, 26 say "[ FIELDS ]"
        @ 24, 0
        @ 24, 0 say padc("Hit ESC to type in Field name", 80)
        if(mGetchoice:=aChoice(16,25,20,36,aFields)) != 0
            mField:=aFields[mGetchoice]
        Else
            @ 8,22 say "ENTER FIELD NAME         :" Get mField pict "@!"
            Read
        End
@ 8,22 say "ENTER FIELD NAME         : "+mField      PiCT "@!"

/*       Get Remaining information        */
@ 7,22 say "ENTER DATABASE NAME      : "+mDatabase   pict "@!"
@ 8,22 say "ENTER FIELD NAME         : "+mField      Pict "@!"
@ 9,22 say "ENTER TEMPORARY FILE NAME:" get mTemporary  Pict "@!" color "gr+/b"
@ 10,22 say "DISPLAY OUTPUT TO SCREEN :" get mDisp pict "Y" color "gr+/b"
Read


/*       Display Session Settings         */
@ 6, 15 Clear to 11, 65
@ 6, 15 to 11, 65 DOUBLE
Sha_shadow(6,15,11,65)
@ 7, 22 say "ENTER DATABASE NAME      : "+mDatabase   pict "@!"
@ 8,22 say "ENTER FIELD NAME         : "+mField      Pict "@!"
@ 9,22 say "ENTER TEMPORARY FILE NAME: "+mTemporary  Pict "@!"
@ 10,22 say "DISPLAY OUTPUT TO SCREEN : "
@ 10,49 say iif(mDisp=.T.,"Y","N")
@ 24,0
@ 24, 0 say padc("Is All The Information Correct?",80)
set cursor off
@ 24,82 get mAny pict "@!"
read
set cursor on

if mAny == "N" .or. mAny == "n"
      Loop
end

/*     Re-Establish Database Work-Areas and Indexes     */
@ 24, 0
@ 24, 0 say padc("Creating Index, Please Wait", 80) color "*W+/b"

Select A
Use &mDatabase New
Index on &mField to Temp
Copy structure to &mTemporary

Select B
Use &mTemporary New

@ 6, 15 Clear to 11, 65
@ 6, 15 to 11, 65 Double
sha_shadow(6,15,11,65)
@ 8, 34 say "WORKING. . ." color "*W+/B"

Select A
Goto top
@ 24, 0
Do While !eof()
   mRec:=recno()
   mCheck:=A->&mField
   @ 24, 10 say "Record: "
   @ 24, 18 say mRec pict "99999"
   @ 24, 25 say "of"
   @ 24,29 say Lastrec() pict "99999"
   @ 24, 40 say "Process Completed: "
   @ 24, 60 say (mRec/lastrec()) * 100 pict "999.9%"

   if(nPos:=Ascan(aVal, mCheck)) != 0
       Select B
       Use &mTemporary
       Append Record aRec[nPos] from &mDatabase
       append record mRec from &mDatabase
       aadd(aDuplicate, "  "+mField+" "+mCheck)
       select A
   else
       aadd(aVal, mCheck)
       aadd(aRec, Recno())
   end
   Skip +1

end

if mDisp == .T.
        @ 6, 15 Clear to 11, 65
        @ 6, 15 to 11, 65 Double
        sha_shadow(6,15,11,65)
        @ 24, 0
        @ 24, 0 say padc("Duplicate Records Listing. .",80) color "*W+/B"
          if(mGetchoic:=aChoice(7,16,10,64,aDuplicate)) = 0
              LOOP
          endif
endif

END

//---------------------------------------------------------------//

FUNCTION sha_shadow(t, l, b, r)

LOCAL shadow_attribute

if r < maxcol() .and. b < maxrow()
    shadow_attribute = iif(iscolor(), COL_SHADOW_ATTRIBUTE, ;
				      BW_SHADOW_ATTRIBUTE)
    sha_attr(b+1,l+1,b+1,r+1,shadow_attribute)
    sha_attr(t+1,r+1,b+1,r+2,shadow_attribute)
endif

RETURN NIL

//---------------------------------------------------------------//

STATIC FUNCTION sha_attr(t, l, b, r, new_attr)

LOCAL old_cr_area, new_scr_area, i

   old_scr_area = savescreen(t, l, b, r)
   new_scr_area = ""

   FOR i = 1 to len(old_scr_area) STEP 2
     new_scr_area = new_scr_area + substr(old_scr_area, i, 1)+chr(new_attr)
   NEXT

   restscreen(t, l, b, r, new_scr_area)


RETURN NIL

Procedure Done

Close all
Clear all
Release all
if File("Temp.ntx")
  delete file temp.ntx
endif
cls
quit
return
